SystemOrganization addCategory: #'Magritte-Tools'!

ORCmdMethodRefactoring subclass: #ORCmdMAMoveDescriptionsToInstanceRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/13/2012 17:56'!
label
	^ 'Update Magritte description'! !

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'accessing' stamp: 'NickAger 1/13/2012 18:07'!
longDescription
	^ 'Move Magritte description to instance side and add a pragma.'! !

!ORCmdMAMoveDescriptionsToInstanceRefactoring methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 11:36'!
refactoring
	^ MAMoveDescriptionsToInstanceRefactoring
		model: self model
		swapMethod: self currentNode selector
		in: self currentNode theClass! !

ORSwapMethodRefactoring subclass: #MAMoveDescriptionsToInstanceRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tools'!

!MAMoveDescriptionsToInstanceRefactoring class methodsFor: 'as yet unclassified' stamp: 'NickAger 1/13/2012 10:42'!
performFor: aClass
	aClass class allSelectors select: #isDescriptionSelector thenDo: [ :each |
		| refactoring |
		refactoring := self model: nil swapMethod: each in: aClass class.
		refactoring execute ]! !

!MAMoveDescriptionsToInstanceRefactoring class methodsFor: 'as yet unclassified' stamp: 'NickAger 1/12/2012 22:21'!
performForAllClasses
	Object allSubclasses do: [ :aClass | 
		(aClass class allSelectors detect: #isDescriptionSelector ifNone: [ nil ]) notNil ifTrue: [
			self performFor: aClass ] ]! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'private' stamp: 'NickAger 1/13/2012 20:53'!
alreadyIncludesMagritteSelectors: parseTree
	^ (parseTree pragmas detect: [ :each | MAPragmaBuilder magritteSelectors includes: each selector ] ifNone: [ nil ]) notNil! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'private' stamp: 'NickAger 1/13/2012 21:07'!
createPragma: parseTree
	((selector = #descriptionContainer) or: [ selector isDescriptionExtension: #descriptionContainer ]) ifTrue: [
		^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder containerPragma) arguments: #() ].
	
	(selector isDescriptionDefinition) ifTrue: [
		^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder descriptionPragma) arguments: #() ].
	
	((selector isDescriptionSelector) and: [ selector numArgs = 1 ]) ifTrue: [
		| descriptionDefinitionSelector |
		
		descriptionDefinitionSelector := class allSelectors detect: [ :each | 
			each isDescriptionDefinition and: [ selector isDescriptionExtension: each ] ] ifNone: [ nil ].
		
		descriptionDefinitionSelector isNil ifTrue: [
			descriptionDefinitionSelector := class soleInstance allSelectors detect: [ :each | 
				each isDescriptionDefinition and: [ selector isDescriptionExtension: each ] ] ifNone: [ nil ] ].
		
		descriptionDefinitionSelector notNil ifTrue: [
			^ RBPragmaNode selectorParts: (Array with: MAPragmaBuilder descriptionExtensionPragma) arguments: (Array with: (RBLiteralValueNode literalToken: descriptionDefinitionSelector))] ].
	^ nil
! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'preconditions' stamp: 'NickAger 1/13/2012 17:56'!
preconditions
	^ RBCondition withBlock: [ selector isDescriptionSelector ]! !

!MAMoveDescriptionsToInstanceRefactoring methodsFor: 'transforming' stamp: 'NickAger 1/13/2012 21:06'!
transform
	| parseTree methodBody |

	parseTree := class parseTreeFor: selector.
	
	(self alreadyIncludesMagritteSelectors: parseTree) ifFalse: [
		| pragma |
		pragma := self createPragma: parseTree.
		pragma notNil ifTrue: [
			parseTree pragmas: (parseTree pragmas, (Array with: pragma)) ] ].
		
	methodBody := class methodFor: selector.
	target compile: (parseTree formattedCode) classified: 'magritte-descriptions'.
	class removeMethod: selector! !
